/**
 * v~eBu^z񑀍NX
 */

package library.graphics;

public class Array {
    //z̍쐬
    public static int[] make(int a1, int a2) {
        int[] array = {
            a1, a2
        };
        return array;
    }
    public static int[] make(int a1, int a2, int a3) {
        int[] array = {
            a1, a2, a3
        };
        return array;
    }

    public static double[] make(double a1, double a2, double a3) {
        double[] array = {
            a1, a2, a3
        };
        return array;
    }
    public static double[] make(double a1, double a2, double a3, double a4) {
        double[] array = {
            a1, a2, a3, a4
        };
        return array;
    }

    //z̕
    public static int[] copy(int[] a1) {
        int[] array = new int[a1.length];
        for(int i=0; i < a1.length; i++)
            array[i] = a1[i];
        return array;
    }
    public static int[][] copy(int[][] a1) {
        int[][] array = new int[a1.length][];
        for(int i=0; i < a1.length; i++) {
            array[i] = new int[a1[i].length];
            for(int j=0; j < a1[i].length; j++)
                array[i][j] = a1[i][j];
        }
        return array;
    }

    public static double[] copy(double[] a1) {
        double[] array = new double[a1.length];
        for(int i=0; i < a1.length; i++)
            array[i] = a1[i];
        return array;
    }
    public static double[][] copy(double[][] a1) {
        double[][] array = new double[a1.length][];
        for(int i=0; i < a1.length; i++) {
            array[i] = new double[a1[i].length];
            for(int j=0; j < a1[i].length; j++)
                array[i][j] = a1[i][j];
        }
        return array;
    }

    //ž
    public static int[] unite(int[] a1, int[] a2) {
        int[] array = new int[a1.length + a2.length];
        for(int i=0; i < a1.length; i++)
            array[i] = a1[i];
        for(int i=0; i < a2.length; i++)
            array[a1.length + i] = a2[i];
        return array;
    }
    public static int[][] unite(int[][] a1, int[][] a2) {
        int[][] array = new int[a1.length + a2.length][];
        for(int i=0; i < a1.length; i++) {
            array[i] = new int[a1[i].length];
            for(int j=0; j < a1[i].length; j++)
                array[i][j] = a1[i][j];
        }
        for(int i=0; i < a2.length; i++) {
            array[a1.length + i] = new int[a2[i].length];
            for(int j=0; j < a2[i].length; j++)
                array[a1.length + i][j] = a2[i][j];
        }
        return array;
    }

    public static double[] unite(double[] a1, double[] a2) {
        double[] array = new double[a1.length + a2.length];
        for(int i=0; i < a1.length; i++)
            array[i] = a1[i];
        for(int i=0; i < a2.length; i++)
            array[a1.length + i] = a2[i];
        return array;
    }
    public static double[][] unite(double[][] a1, double[][] a2) {
        double[][] array = new double[a1.length + a2.length][];
        for(int i=0; i < a1.length; i++) {
            array[i] = new double[a1[i].length];
            for(int j=0; j < a1[i].length; j++)
                array[i][j] = a1[i][j];
        }
        for(int i=0; i < a2.length; i++) {
            array[a1.length + i] = new double[a2[i].length];
            for(int j=0; j < a2[i].length; j++)
                array[a1.length + i][j] = a2[i][j];
        }
        return array;
    }

    //z̒o
    public static int[] extract(int[] a1, int begin, int end) {
        int[] array = new int[end - begin + 1];
        for(int i=0; i <= end - begin; i++)
            array[i] = a1[begin + i];
        return array;
    }
    public static int[][] extract(int[][] a1, int begin, int end) {
        int[][] array = new int[end - begin + 1][];
        for(int i=0; i <= end - begin; i++) {
            array[i] = new int[a1[begin + i].length];
            for(int j=0; j < a1[begin + i].length; j++)
                array[i][j] = a1[i][j];
        }
        return array;
    }

    public static double[] extract(double[] a1, int begin, int end) {
        double[] array = new double[end - begin + 1];
        for(int i=0; i <= end - begin; i++)
            array[i] = a1[begin + i];
        return array;
    }
    public static double[][] extract(double[][] a1, int begin, int end) {
        double[][] array = new double[end - begin + 1][];
        for(int i=0; i <= end - begin; i++) {
            array[i] = new double[a1[begin + i].length];
            for(int j=0; j < a1[begin + i].length; j++)
                array[i][j] = a1[i][j];
        }
        return array;
    }
}